package nl.madline.opendp500;

/**
 * @author svmaris
 */
public class JDPFile implements Comparable {
    private String filename;
    private int timesPlayed;
    private String mediaType;

    /**
     * Default constructor.
     * 
	 * @param filename The name of the file
	 * @param mediaType The media type of the file (AUDIO/VIDEO/PICTURE)
	 */
	public JDPFile(String filename, String mediaType) {
        this.filename = filename;
        this.mediaType = mediaType;
        this.timesPlayed = 0;
    }

    /**
     * Get the number of times this file is played
     * 
	 * @return timesPlayer The number of times this file is played
	 */
	public int getTimesPlayed() {
        return timesPlayed;
    }

    /**
     * Set the number of times this file is played
     * 
	 * @param timesPlayed The number of times this file is played
	 */
	public void setTimesPlayed(int timesPlayed) {
        this.timesPlayed = timesPlayed;
    }

    /**
     * Get the name of this file
     * 
	 * @return filename The name of the file
	 */
	public String getFilename() {
        return filename;
    }

    /**
     * Get the media type of the file
     * 
	 * @return mediaType The media type of the file (AUDIO/VIDEO/PICTURE)
	 */
	public String getMediaType() {
        return mediaType;
    }

    /* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object file) {
        return ((JDPFile)file).getFilename().compareTo(this.filename);
    }
}
