/*
 * JDPconnectWebRadio.java.java
 *
 * Created on 16 avril 2003, 21:50
 */

package nl.madline.opendp500.test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Vector;
/**
 *
 * @author  flo
 * This Class is used to make a connection to the web server Kiss
 * and gets a list of web radios
 */
public class JDPConnectWebRadio {

	/* connection by socket */
	private java.net.Socket server;
	
	/* socket parameters */
	private String Address;
	private int PORT;
	private String PlayerID;
	private int KissLanguage;
	private int PlayerFirmware;
	private int PlayerVersion;
	private String PlayerModel;
	private String PlayerBrand;

	/* stream for communication */
	private PrintWriter out;
	/*private InputStreamReader in; */
	private BufferedReader in;

	public JDPConnectWebRadio(
		String PlayerID,
		String Address,
		int PORT,
		int KissLanguage,
		int PlayerFirmware,
		int PlayerVersion,
		String PlayerModel,
		String PlayerBrand) {
		this.Address = Address;
		this.PORT = PORT;
		this.PlayerID = PlayerID;
		this.KissLanguage = KissLanguage;
		this.PlayerFirmware = PlayerFirmware;
		this.PlayerVersion = PlayerVersion;
		this.PlayerVersion = PlayerVersion;
		this.PlayerBrand = PlayerBrand;
		this.PlayerModel = PlayerModel;

		/* Socket definition */
		try {
			this.server = new java.net.Socket(Address, PORT);
		} catch (IOException e) {
			System.err.println(
				"Failed to connect to " + Address + "(" + PORT + ")");
			System.err.println("Check if the server is online");
		}

		/* Input stream*/
		try {
			/* this.in = new InputStreamReader(this.server.getInputStream());*/
			this.in =
				new BufferedReader(
					new InputStreamReader(this.server.getInputStream()));
		} catch (IOException e) {
			System.err.println("Failed to create inputstream");
			e.printStackTrace();
		}

		/* output stream*/
		try {
			this.out = new PrintWriter(this.server.getOutputStream(), true);
		} catch (IOException e) {
			System.err.println("Failed to create outputstream");
			e.printStackTrace();
		}

		/* some indications */
		System.out.println("Connected to  :" + Address + "(" + PORT + ")");

	}
	public void ListRadio(Vector listButtons, Vector buttons) {

		/* send a request */
		String command =
			"GET http://"
				+ this.Address
				+ "/host.php?PlayerID="				
				+ this.PlayerID
				+ "&PlayerBrand="
				+ this.PlayerBrand
				+ "&PlayerModel="
				+ this.PlayerModel
				+ "&PlayerVersion="
				+ this.PlayerVersion
				+ "&PlayerLanguage="
				+ this.KissLanguage
				+ "&PlayerFirmware="
				+ this.PlayerFirmware
				+ " \n";
		this.out.println(command);
		System.out.println("Send command  : " + command + "\n");

		String read = null;
		/* receiving result */
		try {
			while ((read = this.in.readLine()) != null) {
				if (read.indexOf("]") > -1) {
					/*listButtons.add(read);*/
					StringTokenizer st = new StringTokenizer(read, "]");
					String allparts = "";
					int cpt = 0;
					while (st.hasMoreTokens()) {
						cpt++;
						String part = st.nextToken();
						if (cpt == 1) {
							allparts = allparts + part.trim(); /* radio name */
						} else if (cpt == 2) {
							allparts = allparts + "\t (" + part.trim();
							/* IP */
						} else if (cpt == 4) {
							allparts = allparts + part.trim() + ")"; /* URL */
						}
						allparts = allparts.replaceAll("'", "");

					}
					buttons.add(allparts);
					listButtons.add(allparts + "|" + allparts + "|0|");
				}
			}

		} catch (IOException e) {
			closeConnection();
		}

		/* the end */
		closeConnection();
	}

	private void closeConnection() {
		System.out.println("Closing connection");
		try {
			this.in.close();
			this.out.close();
			this.server.close();
		} catch (Exception e) {
			System.out.println("Couldn't close connection");
		}
	}
}
