/*
 * Created on Apr 21, 2003
 */
package nl.madline.opendp500.web;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import nl.madline.opendp500.JDPServer;

/**
 * @author svmaris
 */
public class JDPWebServer implements Runnable {
	private String DOCUMENT_ROOT = "web";
	private JDPServer dpserver;
	private ServerSocket server;
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	 public JDPWebServer(JDPServer dpserver) {
	 	this.dpserver = dpserver;
	 	
	 	try {
			int port = new Integer(dpserver.getConfig().getProperty("webserver.port")).intValue();
			this.server = new ServerSocket(port);
			
			dpserver.debugMsg("Webserver is running on port " + port);						
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
	 }
	 
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		while(true) {
			try {
				Socket client = server.accept();
				
				new Thread(new JDPWebClientHandler(this, client)).start();
			} catch (IOException e) {				
				e.printStackTrace();
			}
		}

	}
		
	/**
	 * @return DOCUMENT_ROOT The document root of the webserver
	 */
	public String getDocumentRoot() {
		return DOCUMENT_ROOT;
	}

	/**
	 * @return dpserver The JDPServer-object handling the player
	 */
	public JDPServer getDPServer() {
		return dpserver;
	}
}
